%error = forceRequiredAddOn("Event_Variables");
if(%error == $Error::AddOn_NotFound)
{
	error("Script_VCEPrints - required Add-On Event_Variables not found");
	return;
}
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("BottomPrint","VCEPrints","$VCEPrints::BottomPrint","string 255","Script_VCEPrints","",0,1);
	RTB_registerPref("CenterPrint","VCEPrints","$VCEPrints::CenterPrint","string 255","Script_VCEPrints","",0,1);
}
else
{
	if(isobject(localclientconnection))
		clientCmdMessageBoxOk("Add-ons","Script_VCEPrints cannot run because you do not have RTB installed.");
	else
		error("Script_VCEPrints - cannot run because you do not have RTB installed.");
	return;
}

package VCEPrints
{
	function GameConnection::spawnPlayer(%this)
	{
		%ret = Parent::spawnPlayer(%this);
		%this.schedule(100,VCEPrints);
		return %ret;
	}
	function VariableGroup::setVariable(%group,%type,%name,%value,%obj) //for all non-special changes
	{
		Parent::setVariable(%group,%type,%name,%value,%obj);
		if(%obj.getClassName() $= "Player")
			%obj.client.VCEPrints();
		if(%obj.getClassNAme() $= "GameConnection")
			%obj.VCEPrints();
	}
	function GameConnection::setScore(%this,%score) //for <var:cl:score> changes
	{
		%ret = Parent::setScore(%this,%score);
		%this.VCEPrints();
		return %ret;
	}
	function Player::changeDatablock(%this,%data,%c) //for <var:pl:datablock> and <var:pl:maxhealth> changes
	{
		%ret = Parent::changeDatablock(%this,%data,%c);
		if(isObject(%this.client))
			%this.client.VCEPrints();
		return %ret;
	}
	function serverCmdUseTool(%client,%slot) //for <var:pl:currentitem> changes
	{
		Parent::serverCmdUseTool(%client,%slot);
		%client.VCEPrints();
	}
	function serverCmdUnUseTool(%client) //for <var:pl:currentitem> changes
	{
		Parent::serverCmdUnUseTool(%client);
		%client.VCEPrints();
	}
	function serverCmdUseSprayCan(%client,%color) //for <var:pl:currentitem> changes
	{
		Parent::serverCmdUseSprayCan(%client,%color);
		%client.VCEPrints();
	}
	function serverCmdUseFXCan(%client,%id) //for <var:pl:currentitem> changes
	{
		Parent::serverCmdUseFXCan(%client,%id);
		%client.VCEPrints();
	}
	function Armor::onDamage(%data,%this,%damage) //for <var:pl:health> and <var:pl:damage> changes
	{
		%ret = Parent::onDamage(%data,%this,%damage);
		if(isObject(%this.client))
			%this.client.VCEPrints();
		return %ret;
	}
	//The rest would be pointless to put into a bottom/center print.
};
activatePackage(VCEPrints);

function GameConnection::VCEPrints(%this)
{
	%this.centerPrint("<just:right>" @ $VCEPrints::CenterPrint,-1,"");
	%this.bottomPrint($VCEPrints::BottomPrint,-1,"");
}